[SCOI2005]互不侵犯 题解
题目地址:ė …
May all the beauty be blessed.
题目地址:洛谷:【P1066】2^k进制数 – 洛谷
设r是个2^k 进制数,并满足以下条件:
在这里,正整数k(1≤k≤9)和w(k<W≤30000)是事先给定的。
问:满足上述条件的不同的r共有多少个?
我们再从另一角度作些解释:设S是长度为w 的01字符串(即字符串S由w个“0”或“1”组成),S对应于上述条件3中的q。将S从右起划分为若干个长度为k 的段,每段对应一位2^k进制的数,如果S至少可分成2段,则S所对应的二进制数又可以转换为上述的2^k 进制数r。
例:设k=3,w=7。则r是个八进制数(2^3=8)。由于w=7,长度为7的01字符串按3位一段分,可分为3段(即1,3,3,左边第一段只有一个二进制位),则满足条件的八进制数有:
所以,满足要求的r共有36个。
输入格式:
输入只有1行,为两个正整数,用一个空格隔开:
k W
输出格式:
输出为1行,是一个正整数,为所求的计算结果,即满足条件的不同的r的个数(用十进制数表示),要求最高位不得为0,各数字之间不得插入数字以外的其他字符(例如空格、换行符、逗号等)。
(提示:作为结果的正整数可能很大,但不会超过200位)
输入样例#1:
3 7
输出样例#1:
36
NOIP 2006 提高组 第四题
锻炼一下高精。
首先可以很快得到一个DP方程,用dp[i][j]表示最高位为第i位且该位填j的方案数,有dp[1][1~2^k-1]=1,方程如下
dp[i][j] = \sum_{j'=j+1}^{2^k-1} dp[i-1][j']
而答案是 \displaystyle \sum_{i=2}^{\lceil \frac{W}{k} \rceil} \sum_{j=1, k(i-1)+\log_2 j \leq W}^{2^k-1} dp[i][j] ,注意到最高位以后要特判一下超没超W。
然后套个烦人的压位高精板子。有点卡常,最好卡着开空间,加上一个滚动数组。空间开太大memset会TLE。
// Code by KSkun, 2018/4
#include <cstdio>
#include <cmath>
#include <cctype>
#include <cstring>
inline int max(int a, int b) {
return a > b ? a : b;
}
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF : *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
register char c = fgc();
while(!isdigit(c)) {
if(c == '-') neg = -1;
c = fgc();
}
while(isdigit(c)) {
res = (res << 1) + (res << 3) + c - '0';
c = fgc();
}
return res * neg;
}
const int MAXN = 10005;
const int BMO = 1e9;
struct Bint {
int len, num[30];
inline Bint& operator=(const int &rhs) {
num[0] += rhs;
for(register int i = 0; i <= len; i++) {
if(num[i] < BMO) break;
num[i + 1]++;
num[i] -= BMO;
if(i == len) len++;
}
return *this;
}
inline Bint operator+(const Bint &rhs) const {
Bint res = *this;
res.len = max(res.len, rhs.len);
for(register int i = 0; i <= res.len; i++) {
res.num[i] += rhs.num[i];
if(res.num[i] < BMO) continue;
res.num[i + 1]++;
res.num[i] -= BMO;
if(i == res.len) res.len++;
}
return res;
}
inline Bint& operator+=(const Bint &x) {
return *this = *this + x;
}
inline void print() {
for(register int i = len; i >= 0; i--) {
if(i == len) printf("%d", num[i]);
else printf("%09d", num[i]);
}
}
};
int k, w, len[1 << 9];
Bint ans, dp[2][1 << 9];
int main() {
k = readint(); w = readint();
for(register int i = 1; i < 1 << k; i++) {
dp[1][i] = 1;
}
for(register int i = 1; i < 1 << k; i++) {
len[i] = len[i >> 1] + 1;
}
int lim = ceil(double(w) / k);
for(register int i = 2; i <= lim; i++) {
memset(dp[i & 1], 0, sizeof(dp[i & 1]));
for(int j = 1; j < 1 << k; j++) {
for(int jj = j + 1; jj < 1 << k; jj++) {
dp[i & 1][j] += dp[i & 1 ^ 1][jj];
}
if((i - 1) * k + len[j] <= w) ans += dp[i & 1][j];
else break;
}
}
ans.print();
return 0;
}
题目地址:洛谷:【P1641】[SCOI2010]生成字符串 – 洛谷、BZOJ:Problem 1856. — [Scoi2010]字符串
lxhgww最近接到了一个生成字符串的任务,任务需要他把n个1和m个0组成字符串,但是任务还要求在组成的字符串中,在任意的前k个字符中,1的个数不能少于0的个数。现在lxhgww想要知道满足要求的字符串共有多少个,聪明的程序员们,你们能帮助他吗?
输入格式:
输入数据是一行,包括2个数字n和m
输出格式:
输出数据是一行,包括1个数字,表示满足要求的字符串数目,这个数可能会很大,只需输出这个数除以20100403的余数
输入样例#1:
2 2
输出样例#1:
2
对于30%的数据,保证1<=m<=n<=1000
对于100%的数据,保证1<=m<=n<=1000000
30%的做法,设计状态dp[i][j]表示填到第i位,前面有j个0,转移枚举最后一位填啥。复杂度O(n^2)。
100%的做法,就比较玄学了。
我们考虑上面的状态,把它改成dp[i][j]表示填到第i位,1的个数与0的个数之差为j的状态,转移是这样的
[eq]\displaystyle dp[i][j] = dp[i-1][j+1]+dp[i-1][j-1][/eq]
把状态的转移在二维平面中表示出来,发现末尾选1就表示向右上方走,选0表示向右下方走。起点是(0, 0),终点是(n+m, n-m),求这样的路径数,相当于从n+m步里选择m步向右下走,即[eq]\mathrm{C}_{n+m}^m[/eq]。不合法的方案在这里则接触/越过了y=-1这条线。由对称性,我们知道(0, -2)到终点的路径翻折一下就是(0, 0)到终点且经过y=-1的路径,因此不合法的路径就是(0, -2)到终点的路径数,相当于从n+m步里选择m-1步向右下走,即[eq]\mathrm{C}_{n+m}^{m-1}[/eq]。答案为[eq]\mathrm{C}_{n+m}^m-\mathrm{C}_{n+m}^{m-1}[/eq]。随便算一下阶乘搞一下逆元就可以了,模数是质数所以可以用费马小定理。复杂度O(n)。
// Code by KSkun, 2018/4
#include <cstdio>
#include <cstring>
typedef long long LL;
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF : *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
register char c = fgc();
while(c < '0' || c > '9') {
if(c == '-') neg = -1;
c = fgc();
}
while(c >= '0' && c <= '9') {
res = res * 10 + c - '0';
c = fgc();
}
return res * neg;
}
const int MO = 20100403;
LL n, m, ans;
inline LL fpow(LL n, LL k) {
LL res = 1;
while(k) {
if(k & 1) res = res * n % MO;
n = n * n % MO;
k >>= 1;
}
return res;
}
int main() {
n = readint(); m = readint(); n += m;
LL nr = 1, mr = 1, nmr = 1;
for(LL i = 1; i <= n; i++) {
if(i <= m) mr = mr * i % MO;
if(i <= n - m) nmr = nmr * i % MO;
nr = nr * i % MO;
}
ans = nr * fpow(mr, MO - 2) % MO * fpow(nmr, MO - 2) % MO;
m--;
nr = 1; mr = 1; nmr = 1;
for(LL i = 1; i <= n; i++) {
if(i <= m) mr = mr * i % MO;
if(i <= n - m) nmr = nmr * i % MO;
nr = nr * i % MO;
}
ans -= nr * fpow(mr, MO - 2) % MO * fpow(nmr, MO - 2) % MO;
ans = (ans % MO + MO) % MO;
printf("%lld", ans);
return 0;
}
题目地址:洛谷:【P2183】[国家集训队]礼物 – 洛谷、BZOJ:Problem 2142. — 礼物
一年一度的圣诞节快要来到了。每年的圣诞节小E都会收到许多礼物,当然他也会送出许多礼物。不同的人物在小E心目中的重要性不同,在小E心中分量越重的人,收到的礼物会越多。小E从商店中购买了n件礼物,打算送给m个人,其中送给第i个人礼物数量为wi。请你帮忙计算出送礼物的方案数(两个方案被认为是不同的,当且仅当存在某个人在这两种方案中收到的礼物不同)。由于方案数可能会很大,你只需要输出模P后的结果。
输入格式:
输入的第一行包含一个正整数P,表示模;
第二行包含两个整整数n和m,分别表示小E从商店购买的礼物数和接受礼物的人数;
以下m行每行仅包含一个正整数wi,表示小E要送给第i个人的礼物数量。
输出格式:
若不存在可行方案,则输出“Impossible”,否则输出一个整数,表示模P后的方案数。
输入样例#1:
100 4 2 1 2
输出样例#1:
12
输入样例#2:
100 2 2 1 2
输出样例#2:
Impossible
【样例说明】
下面是对样例1的说明。
以“/”分割,“/”前后分别表示送给第一个人和第二个人的礼物编号。12种方案详情如下:
1/23 1/24 1/34
2/13 2/14 2/34
3/12 3/14 3/24
4/12 4/13 4/23
设P=p1^c1 * p2^c2 * p3^c3 * … * pt ^ ct,pi为质数。
对于15%的数据,n≤15,m≤5,pi^ci≤10^5;
在剩下的85%数据中,约有60%的数据满足t≤2,ci=1,pi≤10^5,约有30%的数据满足pi≤200。
对于100%的数据,1≤n≤10^9,1≤m≤5,1≤pi^ci≤10^5,1≤P≤10^9。
本题需要的数学姿势有:数学笔记:数论(Lucas、CRT) | KSkun’s Blog
参考资料:题解 P2183 【[国家集训队]礼物】 – 没名字可被用的博客 – 洛谷博客
无解仅当\sum_{i=1}^m w_i < n。
有解的情况下,要求的就是\mathrm{C}_n^{w_1} \times \mathrm{C}_{n-w_1}^{w_2} \times \cdots \bmod P,对于每个组合数,应用扩展Lucas定理求解即可。
// Code by KSkun, 2018/4
#include <cstdio>
typedef long long LL;
struct Num {
LL num, pcnt; // pcnt: p因子数量,num: 提取p因子后乘起来的积
Num(LL num = 0, LL pcnt = 0): num(num), pcnt(pcnt) {}
};
inline char fgc() {
static char buf[100000], *p1 = buf, *p2 = buf;
return p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, 100000, stdin), p1 == p2) ? EOF
: *p1++;
}
inline LL readint() {
register LL res = 0, neg = 1;
char c = fgc();
while(c < '0' || c > '9') {
if(c == '-') neg = -1;
c = fgc();
}
while(c >= '0' && c <= '9') {
res = res * 10 + c - '0';
c = fgc();
}
return res * neg;
}
const int MAXN = 100005, MAXM = 10;
const LL INF = 1e15;
inline LL fpow(LL n, LL k, LL p) {
LL res = 1; n %= p;
while(k) {
if(k & 1) res = res * n % p;
n = n * n % p;
k >>= 1;
}
return res;
}
LL P, n, m, w[MAXM];
// calculate prime divisors in x
LL divi[MAXN], dcnt[MAXN], dpow[MAXN], dtot;
inline void calDivisor(LL x) {
dtot = 0;
for(LL i = 2; i * i <= P; i++) {
if(x % i == 0) {
divi[++dtot] = i;
while(x % i == 0) {
x /= i; dcnt[dtot]++;
}
dpow[dtot] = fpow(i, dcnt[dtot], INF);
}
}
if(x != 1) {
dtot++;
divi[dtot] = dpow[dtot] = x; dcnt[dtot] = 1;
}
}
// calculate x! mod p^k
inline Num calFactorial(LL x, LL id) {
if(x == 1 || x == 0) return Num(1, 0); // 1! = 0! = 1
LL pk = dpow[id], res = 1;
LL pnum = 0;
for(LL i = x; i; i /= divi[id]) pnum += i / divi[id]; // 计算p因子的数量
Num nxt = calFactorial(x / divi[id], id); // 递归计算提取了一个p因子的p倍数组成的阶乘
res = res * nxt.num % pk; // 合并答案
if(x >= pk) { // 如果有多段超过p^k的,预处理应用快速幂
LL fac = 1;
for(LL i = 1; i < pk; i++) {
if(i % divi[id] == 0) continue;
fac = fac * i % pk;
}
res = res * fpow(fac, x / pk, pk) % pk;
}
for(LL i = x; i >= 1; i--) { // 非整段p^k,暴力求解
if(i % pk == 0) break;
if(i % divi[id] == 0) continue;
res = res * i % pk;
}
return Num(res, pnum);
}
inline LL exgcd(LL a, LL b, LL &x, LL &y) {
if(!b) {
x = 1; y = 0; return a;
}
LL res = exgcd(b, a % b, x, y);
LL t = x; x = y; y = t - a / b * y;
return res;
}
inline LL calInverse(LL n, LL p) {
LL x, y;
exgcd(n, p, x, y);
return (x % p + p) % p;
}
LL crtm[MAXN];
// CRT求解组合数
inline LL crt() {
LL res = 0;
for(int i = 1; i <= dtot; i++) {
res = (res + crtm[i] * P / dpow[i] % P * calInverse(P / dpow[i], dpow[i]) % P) % P;
}
return res;
}
int main() {
P = readint(); n = readint(); m = readint();
LL wsum = 0;
for(int i = 1; i <= m; i++) {
w[i] = readint();
wsum += w[i];
}
if(wsum > n) {
puts("Impossible"); return 0;
}
calDivisor(P);
LL ans = 1;
for(int i = 1; i <= m; i++) {
for(int j = 1; j <= dtot; j++) {
Num N = calFactorial(n, j),
M = calFactorial(w[i], j),
NM = calFactorial(n - w[i], j);
// 分别代表n!、m!、(n-m)!
N.pcnt -= M.pcnt + NM.pcnt;
if(N.pcnt >= dcnt[j]) { // 如果p因子更多,说明能整除,模意义下为0
crtm[j] = 0;
} else {
crtm[j] = N.num * calInverse(M.num, dpow[j]) % dpow[j]
* calInverse(NM.num, dpow[j]) % dpow[j]
* fpow(divi[j], N.pcnt, dpow[j]) % dpow[j]; // 把p因子乘进去
}
}
ans = ans * crt() % P;
n -= w[i];
}
printf("%lld", ans);
return 0;
}